# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

# Test::LeakTrace isn't available unless we have Test::More ≥ 0.62
%global very_old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.62) ? 1 : 0);' 2>/dev/null || echo 0)

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Package-Stash-XS
Version:	0.28
Release:	2.%{__distinit}%{__distvers}
Summary:	Faster and more correct implementation of the Package::Stash API
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Package-Stash-XS/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DO/DOY/Package-Stash-XS-%{version}.tar.gz
Patch0:		Package-Stash-XS-0.27-old-eumm.patch
Patch1:		Package-Stash-XS-0.27-old-Test::More.patch
Patch2:		Package-Stash-XS-0.26-no-Test::LeakTrace.patch
Patch3:		Package-Stash-XS-0.26-no-Test::Requires.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl >= 3:5.8.1
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(lib)
%if %(perl -e 'print $] >= 5.014 ? 1 : 0;')
BuildRequires:	perl(Package::Anon)
%endif
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Fatal)
%if ! %{very_old_test_more}
BuildRequires:	perl(Test::LeakTrace)
%endif
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
# Test::Requires needs Test::Builder::Module (FC-5, perl 5.8.8 onwards)
%if %(perl -e 'print (($^V and $^V ge 5.8.8) ? 1 : 0);')
BuildRequires:	perl(Test::Requires)
%endif
BuildRequires:	perl(Variable::Magic)
BuildRequires:	perl(XSLoader)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This is a back-end for Package::Stash, which provides the functionality in a
way that's less buggy and much faster. It will be used by default if it's
installed, and should be preferred in all environments with a compiler.

%prep
%setup -q -n Package-Stash-XS-%{version}

# Don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0
%endif

# Patch test suite to work with old Test::More versions if necessary
%if %{old_test_more}
%patch1 -p1
%endif

# Skip the memory leak tests if we don't have Test::LeakTrace
%if %{very_old_test_more}
%patch2 -p1
%endif

# Test::Requires needs Test::Builder::Module (FC-5, perl 5.8.8 onwards)
%if %(perl -e 'print (($^V and $^V ge 5.8.8) ? 0 : 1);')
%patch3 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorarch}/auto/Package/
%{perl_vendorarch}/Package/
%{_mandir}/man3/Package::Stash::XS.3pm*

%changelog
* Tue Jul 23 2013 Paul Howarth <paul@city-fan.org> - 0.28-2
- Perl 5.18 rebuild

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 0.28-1
- Update to 0.28
  - Fix test issue

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
  - Handle magic more correctly in add_symbol and get_or_add_symbol
- Add upstream patch to avoid build dependency on Package::Stash
- BR: perl(Variable::Magic) for the test suite
- Update patches as needed

* Fri Jan  4 2013 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - Internal refactorings to support Package::Anon stashes
- BR: perl(base), perl(constant) and perl(Test::Requires) for test suite
- BR: perl(Package::Anon) for test suite if we have perl ≥ 5.14
- Update patches for old distro compatibility
- Explicitly run the release/author tests
- Add patch to support building without Test::Requires on ancient distros

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.25-3
- BR: perl(File::Temp), perl(lib), perl(Scalar::Util) and perl(XSLoader)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25
  - Fix compilation on perl 5.8 (CPAN RT#70762)
- Drop upstreamed patch for CPAN RT#70762

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
  - Invalid package names (for instance, Foo:Bar) are not allowed
  - Invalid stash entry names (anything containing ::) are not allowed
- Add patch to support perl 5.8 due to pregcomp API change (CPAN RT#70762)
- Update patches to apply cleanly

* Tue Aug  9 2011 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Fix the test for scalar values, again
  - Disallow assigning globrefs to scalar glob slots (this doesn't actually
    make any sense)
- Update patches for old ExtUtils::MakeMaker and Test::More versions

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.22-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sat Mar  5 2011 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22
  - Make the namespace cache lazy and weak, in case the stash is deleted
  - However, this doesn't work on 5.8, so disable the namespace caching
    entirely there
- Update patches to apply cleanly

* Tue Jan 25 2011 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Make the leak tests author-only, since some smokers run release tests
  - Fix some XS forward compat stuff
- Update patches to apply cleanly

* Wed Jan 12 2011 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - Lower perl prereq to 5.8.1
  - Make the leak tests release-only
- Update patches to apply cleanly
- Drop no-Test::Requires patch, no longer needed
- Drop buildreq perl(Test::Requires), no longer needed
- Add patch to skip memory leak tests if we don't have Test::LeakTrace

* Thu Jan  6 2011 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19 (more correct validity test for scalars)
- Update patch for old Test::More versions

* Wed Nov 17 2010 Paul Howarth <paul@city-fan.org> - 0.17-1
- Initial RPM build
